package cz.muni.fi.pa165.controller;

import cz.muni.fi.pa165.model.BandManagerDTO;
import cz.muni.fi.pa165.service.BandManagerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class BandManagerControllerImpl implements BandManagerController{
    private final BandManagerService bandManagerService;

    @Autowired
    public BandManagerControllerImpl(BandManagerService bandManagerService) {
        this.bandManagerService = bandManagerService;
    }

    @Override
    public ResponseEntity<BandManagerDTO> createBandManager(BandManagerDTO bandManagerDTO) {
        return ResponseEntity.status(HttpStatus.CREATED).body(bandManagerService.createBandManager(bandManagerDTO));
    }

    @Override
    public ResponseEntity<BandManagerDTO> getBandManagerById(long id) {
        return ResponseEntity.ok(bandManagerService.getBandManagerByID(id));
    }

    @Override
    public ResponseEntity<BandManagerDTO> updateBandManagerById(long id, BandManagerDTO bandManagerDTO) {
        return ResponseEntity.ok(bandManagerService.updateBandManagerByID(bandManagerDTO));
    }

    @Override
    public ResponseEntity<BandManagerDTO> removeBandManagerById(long id) {
        bandManagerService.removeBandManagerByID(id);
        return ResponseEntity.noContent().build();
    }

}
